c234567
      program rnx2txt
      implicit double precision (a-h,o-z)
      character line*80,dtype(12)*2,fmtlp*70,sta*4,fmtsat*70,
     * tipo(150)*1,dati*80,dato*13
      integer c1,p2,p1,d1,d2
      dimension vtmp(8),isat(150),ias(8),isn(8)
      parameter(c=299792458.d0,f0=10.23D+6)

c ------------------------------------------------------------
c     This program reads a RINEX measuremet file and writes 
c     the measuremets in collums (one row for each satellite).
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

c       Initialization --------------------------------
        l1=0
        l2=0
        c1=0
        p1=0
        p2=0
        d1=0
        d2=0
        f1=154.d0*f0
        f2=120.d0*f0
c       -----------------------------------------------


        call getarg(1,dati)

        open (10,file=dati) 

        write(dato,'(a,a)') dati(1:11),".a"
        open (11,file=dato)

10      read(10,'(a)',end=1000,err=100) line

        if(line(1:11).eq."END OF FILE") goto 1000
        if(line(61:71).eq."MARKER NAME") read(line(1:4),*) sta

c       ...................................................
        if(line(61:79).eq."# / TYPES OF OBSERV")then
         read(line,*)ntypes
         read(line,*)vtemp,(dtype(i),i=1,ntypes)
         do i=1,ntypes
          if(dtype(i).eq."L1")l1=i
          if(dtype(i).eq."L2")l2=i
          if(dtype(i).eq."P2")p2=i
          if(dtype(i).eq."C1")c1=i
          if(dtype(i).eq."P1")p1=i
          if(dtype(i).eq."D1")d1=i  
          if(dtype(i).eq."D2")d2=i  
         enddo
         write(fmtlp,'(a,i1,a)') '(',ntypes,'(f14.3,2i1))'
        endif
c       ...................................................

        ksat=0
        read(line(1:32),'(5(1x,i2),1x,f10.6,2(1x,i2))',
     *    err=100) iyy,mm,iday,ixh,ixm,xs,itmp1,ksat
        write(fmtsat,'(a,i2.2,a)') '(',ksat,'(a,i2))'
        read(line(33:80),fmtsat,err=100)(tipo(i),isat(i),i=1,ksat)

        do i=1,ksat
         if (ntypes.le.5) then
           read(10,fmtlp,err=100)(vtmp(j),ias(j),isn(j),j=1,ntypes)
          else
           read(10,fmtlp,err=100)(vtmp(j),ias(j),isn(j),j=1,5)
           read(10,fmtlp,err=100)(vtmp(j),ias(j),isn(j),j=6,ntypes)
         endif
60       continue
         is=isat(i)
         if ((tipo(i).eq."S").or.(tipo(i).eq."s")) is=is+100

         xl1=0.d0
         isn1=0
         if (l1.gt.0) then 
           xl1=vtmp(l1)*c/f1
           isn1=isn(l1)
         endif 
         xl2=0.d0
         isn2=0
         if (l2.gt.0) then
           xl2=vtmp(l2)*c/f2
           isn2=isn(l2)
         endif

         xc1=0.d0
         if (c1.gt.0) xc1=vtmp(c1)
         xp1=0.d0
         if (p1.gt.0) xp1=vtmp(p1)
         xp2=0.d0
         if (p2.gt.0) xp2=vtmp(p2)
         xd1=0.d0
         if (d1.gt.0) xd1=vtmp(d1)
         xd2=0.d0
         if (d2.gt.0) xd2=vtmp(d2)


         xyear=dble(iyy)
         xmon= dble(mm) 
         xday= dble(iday)
         isec=ixh*3600+ixm*60
         sec=dble(isec)+xs
 
         call sub_cal2dgpsws(xyear,xmon,xday,sec,idoy,nw,sw)    

         if (xp1.lt.1.d-3) xp1=xc1
         
         call lwcase(sta)

         write(11,70) sta,idoy,sec,is,xl1,xl2,xp1,xp2,0
70       format(a4,1x,i3,1x,f8.2,1x,i3,4(1x,f13.3),1x,i1)   


cc         write(*,80) is,iyear,mm,iday,ixh,ixm,xs,xl1,xl2,
cc     *                 xc1,xp1,xp2,xd1,xd2,isn1,isn2
cc80       format(i3,1x,i4,1x,4(i2,1x),f5.2,5(1x,f13.3),
cc     *    2(1x,f10.3),2(1x,i2))

       enddo

100    continue
       goto 10

1000  continue
      end

c  ------------------------------------------------------------------------

         subroutine sub_cal2dgpsws(year,xmonth,day,sec,idoy,nw,sw)
         implicit double precision (a-h,o-z)
 
c        --------------------------------------------------------
c        Compute the  DOY from YEAR MONTH DAY
c
c        1) Until February 28th of 2100 it calculate consitent doys
c           days. Outside this range there will be a discrepancy which
c           increases by one day for every non-leap century year.
c        2) If the year is given with only two digits, the range is
c           between 1980 to 2079
c        --------------------------------------------------------
 
c         print *, "YYY",year,xmonth,day,sec
         xy=year
c        two digits iyear control ...........
         if (xy.lt.100.d0) then
            if (xy.lt.80.d0) then
               xy=xy+2000.d0
             else
               xy=xy+1900.d0
            endif
         endif
c        ....................................
         xm=xmonth
 
         jd0=int(365.25d0*(xy-1.d0))+428
         if (xm.le.2.d0) then
           xy=xy-1.d0
           xm=xm+12.d0
         endif
         jd=int(365.25d0*xy)+int(30.6001d0*(xm+1.d0))-jd0
         doy=dble(jd)+day
         idoy=nint(doy)
 
c        GPS day: (1980jan6.0 => JD=2444244.5 => id_GPS=1.0 )
         id_GPS=jd0+idoy-723263
c        Day of week:
         idw=mod(id_GPS,7)
c        Number of GPS week:
         nw=(id_GPS-idw)/7
c        seconds into the week:
         sw=dble(idw)*86400.d0+sec
 
         return
         end
c        -----------------------------------------------------------                                                         
         subroutine lwcase(string)
         implicit none
 
         character string*(*)
         integer*4 position
         integer*4 i
 
         do position=1,16
           i=ichar(string(position:position))
           if (i.ge.65.and.i.le.90) then
             string(position:position)=char(i+32)
           endif
         enddo
 
        return
 
        end                                                                              
c      -----------------------------------------------------------           

c     f77 -o rnx2txt rnx2txt.f
