cx234567
      implicit double precision (a-h,o-z)
      dimension r(3),v(3),c(3),ve(3)


c   ..........................................................
c
c    [r,v]  ------> |rv2ele_orb| -->  [a,e,i,OMEGA,omega,M]
c    (equatorial)
c     x => Aries
c     z => North Pole
c    (units: km and km/s)            (units: km and rad)
c
c   ----------------------------------------------------------
c     Note: M=n(t-T) with n=dsqrt(gm/a**3)
c   ..........................................................
c
c
c  Example1:
c  echo "-15334. -2312. -21208. .994 -3.770 -.359" |rv2ele_orb
c
c  Result:
c         26549.521 .015 .947 -1.247 -2.477 .782
c
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------


        gm=398600.5d0
        pi=3.1415926535898d0

10      continue
        read (*,*,end=100) r,v

        rr=dsqrt(r(1)**2+r(2)**2+r(3)**2)
        vv=dsqrt(v(1)**2+v(2)**2+v(3)**2)

        c(1)=r(2)*v(3)-r(3)*v(2)
        c(2)=r(3)*v(1)-r(1)*v(3)
        c(3)=r(1)*v(2)-r(2)*v(1)
        cc=dsqrt(c(1)**2+c(2)**2+c(3)**2)

        ve(1)=(-c(2)*v(3)+c(3)*v(2))/gm-r(1)/rr

        ve(2)=(-c(3)*v(1)+c(1)*v(3))/gm-r(2)/rr
        ve(3)=(-c(1)*v(2)+c(2)*v(1))/gm-r(3)/rr

        ex=dsqrt(ve(1)**2+ve(2)**2+ve(3)**2)
        a=1.d0/(2.d0/rr-vv**2/gm)                                               
        Wg=datan2(c(1),-c(2))
        xi=dacos(c(3)/cc)
        wp=datan2(ve(3)/dsin(xi),(ve(1)+dsin(Wg)*ve(3)*
     *     dcos(xi)/dsin(xi))/dcos(Wg))
        E=dacos((1.d0-rr/a)/ex)
        control=r(1)*v(1)+r(2)*v(2)+r(3)*v(3)
        if (control.lt.0.d0) E=-E
        xn=dsqrt(gm/a**3)
        xM=E-ex*dsin(E)

c       TT=t-xM/xn
c       if (TT.lt.0.d0) TT=TT+2.d0*pi/xn

        write(*,'(f16.9,1x,f16.9,1x,f16.9,1x,f16.9,1x,
     *  f16.9,1x,f16.9)') a,ex,xi,Wg,wp,xM
        goto 10

100     continue

        end


c       f77 -o  rv2ele_orb rv2ele_orb.f
