C23456789012345678901234567890123456789012345678901234567890123456789012

        program Gnav

        parameter (nts=40,nac=20)
        implicit double precision (a-h,o-z)
        character line*900,line1*80,dtype(12)*2,fmtlp*70,
c        character line*210,line1*80,dtype(12)*2,fmtlp*70,
     *   fmtsat*70,tipo(nts)*1,sta*4,typ*3,xdump*5

        dimension aa(305),ai(38),epha(nts,38,nac),eph(nts,38),
     *   ee(38),insat(nts),vtmp(8),isn(8),ias(8),xC1(nts),
     *   xL1(nts),i2PRN(nts),xs(nts),ys(nts),zs(nts),dt_sat(nts),
     *   PR(nts),B(nts),BTB(10),Bi1(4),Bia(4),BT1(4),BTaj(4),
     *   coef(3),r1(4),r2(4),xM(4),r_rec(3),r0_rec(3),r_sat(3),
     *   GG(4),URA(nts),GWy(4),GWG(10),xe(4),tt0(nts),GTG(10)

        namelist /parameters/iprint_mess,ele_min,make_relat,
     *   make_iono,make_tropo,make_TGD,sat_corr_emis,
     *   mrealtime

c ------------------------------------------------------------
c
c           sta.pos= [sta x_sta,y_sta,z_sta]
c             where:
c              * sta: station name
c              * (x_sta,y_sta,z_sta) are WGS84 receiver 
c                     [meters]           location coord.
c
c            The coordinates of sta.pos are only used as a reference
c            They are not used at all to initialize the algorithm.
c
c
c       ---- gnav.nml -----------------------------------------
c
c        - Verbose mode:
c          iprint_mess= 0 [No (default)], 
c                       1,2,3
c
c        ......................................................
c        - Elevation Cut-Off:
c
c          ele_min= 5.0  (default)
c
c        ......................................................        
c        - Real-Time Mode:
c           mrealtime=  0 [NO (default)]
c                       1 [YES]
c
c        ......................................................
c        - Satellite Coordinates at Emission time
c           sat_corr_emis=  1 [YES =>  emission-time (default)]
c                           0 [NO] => reception-time
c        ......................................................
c
c        - Make ionospheric Correction
c           make_iono=  1 [YES (default)]
c                       0 [NO]
c
c        - Make tropospheric Correction
c           make_tropo= 1 [YES (default)]
c                       0 [NO]
c
c        - Make relativistic Correction
c           make_relat= 1 [YES (default)] 
c                       0 [NO]
c
c        - Make TGD (sat Instrumental delay) Correction
c           make_TGD=   1 [YES (default)]
c                       0 [NO]
c       ------------------------------------------------------
c
c
c
c INPUT data:
c ***********
c
c       
c  * Post-process (mrealtime= 0)
c  =============================
c
c   RINEX measurement and ephemeris files (gage1470.05o, gage1470.05n).
c
c
c   cat gage1200.05n > EPH.dat
c
c
c   cat gage1200.05o |Gnav > solution
c                      ^ ^
c                      | |
c                      | |
c                      |  +---gnav.nml
c                      |      sta.pos
c                      |
c                    EPH.dat
c                   (RINEX format)
c
c
c
c OUTPUT data (solution)
c **********************
c
c
c ---------------------------------------------------------------------
c YY DOY sec_day dEast dNorth dUP GDOP PDOP TDOP Lon Lat H dt_rec Nsat
c  (GPS time)        (meters)                     (deg  (meters)
c ---------------------------------------------------------------------
c
c ----------------------------------------------------------------------
c
c
c
c  * Real-Time mode (mrealtime= 1)
c  ================================
c
c          OBS
c          EPH  ----->  |Gnav > solution
c          KLB            ^ 
c                         |
c                         |
c                         +---gnav.nml
c                             sta.pos
c
c
c
c --------------------------------------------------------------------\\
c   1   2  3  4  5  6  7   8  9:32 34:58 59:83 84:108 109:133 134:158 \\
c"OBS" YY MM DD HH MN SS  nsat PRN  C1    P1     P2     L1      L2    \\
c        (GPS time)                       (meters)                    \\
c --------------------------------------------------------------------\\
c
c ------------------------------------------------
c 159:183 184:208 209:233 234:258 259:283 284:308]
c   D1      D2      SN1     SN2    LLI1   LLI2
c                    (dB/Hz)
c ------------------------------------------------
c
c      _______________________________________________________________
c      "EPH" Rinex navigation message, but: EACH SATELLITE IN ONE LINE 
c      ---------------------------------------------------------------
c
c      ---------------------------------------------------
c      "KLB" alpha0, alpha2,alpha3,beta0,beta1,beta2,beta3
c      ---------------------------------------------------
c
c
c
c OUTPUT data (solution)
c **********************
c
c
c ---------------------------------------------------------------------
c YY DOY sec_day dEast dNorth dUP GDOP PDOP TDOP Lon Lat H dt_rec Nsat
c  (GPS time)        (meters)                     (deg  (meters)
c ---------------------------------------------------------------------
c
c ----------------------------------------------------------------------




c -----------------------------------------------------------
        
        pi=3.1415926535898d0
        r2g=180.d0/pi
        g2r=pi/180.d0
        w2s=604800.d0

c       Light speed (m/s)
        c=299792458.d0
        f0=10.23D+6
        f1=154.d0*f0
        f2=120.d0*f0
c       wt (rad/s)
        wt=7.2921151467d-5
c       xf:=-2*dsqrt(xmu)/c**2  (s/m**(1/2))
        xf=-4.442807633d-10

c       Time interval to accumulate orbits
cc        dt_acum=dble(nac)*3600
        dt_acum=7200.d0

c       Time-Out broadcast orbits interval:
        dt_cad_eph=3.d0*3600.d0

c       Tolerance for solution convergence
        tol_conv=1.d-1

c       Tolerance to initialize with Bancroft
        tol_lin= 40.d6 


c      Initilization:
c      --------------
        typ="  "
        iprint_mess=0
        ele_min=5.d0
        sat_corr_emis=1
        make_iono=1
        make_tropo=1
        make_TGD=1
        make_relat=1
        mrealtime=0
        Nitc=0
        ibancroft=0
        rr0=0.d0
        do i=1,305
          aa(i)=0.d0
        enddo
        do i=1,38
          ai(i)=0.d0
          ee(i)=0.d0
        enddo
        do i=1,nts
          xC1(i)=0.d0
          xL1(i)=0.d0
          i2PRN(i)=0
          xs(i)=0.d0
          ys(i)=0.d0
          zs(i)=0.d0
          dt_sat(i)=0.d0
          PR(i)=0.d0
          URA(i)=0.d0
          tt0(i)=0.d0
          do j=1,38
             eph(i,j)=0.d0
             do k=1,nac
              epha(i,j,k)=0.d0
             enddo
          enddo
        enddo
        do i=1,10
         BTB(i)=0.d0
         GWG(i)=0.d0
         GTG(i)=0.d0
        enddo
        do i=1,4
          Bi1(i)=0.d0
          Bia(i)=0.d0
          BT1(i)=0.d0
          BTaj(i)=0.d0
          r1(i)=0.d0
          r2(i)=0.d0
          xM(i)=1.d0
          GWy(i)=1.d0
          xe(i)=0.d0
        enddo  
        xM(4)=-1.d0
        do i=1,3
          r0_rec(i)=0.d0
          r_rec(i)=0.d0
          r_sat(i)=0.d0
        enddo

        open (10,file="gnav.nml")
        read (10,nml=parameters,end=10)
10      continue
        close(10)

c       Reading the Receiver coordinates
        open(10,file="sta.pos")
        read(10,*,end=15,err=15) sta,(r0_rec(i),i=1,3)
        close(10)
        call sub_car2geo(r0_rec(1),r0_rec(2),r0_rec(3),
     *     xlan0,xfi0,HH0)
        
        rr0=r0_rec(1)**2+r0_rec(2)**2+r0_rec(3)**2


15      continue


        if (mrealtime.eq.1) goto 35
        open(10,file="EPH.dat")



20      continue
        if (mrealtime.eq.1) goto 35

c       .... Reading the RINEX measurement file ..........
c           --------------------------------------------------
c           NOTE: the GLONASS satellites are read but excluded
c           --------------------------------------------------

30          continue
            read(*,'(a)',end=1000,err=1000) line1
 
cc            print *,"LL",line1 
            if(line1(1:11).eq."END OF FILE") goto 1000

c           ...................................................
            if(line1(61:79).eq."# / TYPES OF OBSERV")then
             read(line1,*)ntypes

             if ((ntypes.le.0).or.(ntypes.gt.8)) print *,"ERROR ntypes"

             read(line1,*) vtemp,(dtype(i),i=1,ntypes)
             do i=1,ntypes
              if(dtype(i).eq."L1")il1=i
              if(dtype(i).eq."L2")il2=i
              if(dtype(i).eq."P2")ip2=i
              if(dtype(i).eq."C1")ic1=i
              if(dtype(i).eq."P1")ip1=i
              if(dtype(i).eq."D1")id1=i
              if(dtype(i).eq."D2")id2=i
             enddo
             write(fmtlp,'(a,i1,a)') '(',ntypes,'(f14.3,2i1))'
            endif
c           ...................................................


            ksat=0
            do i=1,305
             aa(i)=0.d0
            enddo

            read(line1(1:32),'(5(1x,i2),1x,f10.6,2(1x,i2))',
     *       err=30) iyear,imon,iday,ihour,imin,xsec,itmp1,ksat

            if (ksat.eq.0) goto 30

            if (iyear.ge.80) then
               iyear=iyear+1900
              else
               iyear=iyear+2000
            endif

            xyear=dble(iyear)
            xmon=dble(imon)
            xday=dble(iday)
            xhour=dble(ihour)
            xmin=dble(imin)
            secd=((xhour*60.d0)+xmin)*60.d0+xsec

            call sub_cal2dgpsws(xyear,xmon,xday,secd,idoy,nw,sw)
            t=sw+w2s*dble(nw)
c            ........................................................

            write(fmtsat,'(a,i2.2,a)') '(',ksat,'(a,i2))'

            if (ksat.le.12) then
               read(line1(33:80),fmtsat,err=30)
     *                       (tipo(i),insat(i),i=1,ksat)
              else
               read(line1(33:80),fmtsat,err=30)
     *                       (tipo(i),insat(i),i=1,12)

               read(*,'(a)',end=1000,err=1000) line1
               read(line1(33:80),fmtsat,err=30)
     *                       (tipo(i),insat(i),i=13,ksat)
            endif


            aa(1)=xyear
            aa(2)=nw
            aa(3)=sw
            aa(4)=dble(ksat)

            ntot=0
            do i=1,ksat
               if (ntypes.le.5) then
                   read(*,fmtlp,err=30)
     *                (vtmp(j),ias(j),isn(j),j=1,ntypes)
                 else
                   read(*,fmtlp,err=30)
     *                     (vtmp(j),ias(j),isn(j),j=1,5)
                   read(*,fmtlp,err=30)
     *                (vtmp(j),ias(j),isn(j),j=6,ntypes)
               endif

c              --- excluding GLONASS satellites -----------
               if ((tipo(i).eq."R").or.
     *                      (tipo(i).eq."r")) goto 90
c              --------------------------------------------
               ntot=ntot+1

               is=insat(i)
               if((tipo(i).eq."S").or.(tipo(i).eq."s").or.
     *                                   (tipo(i).eq."1"))then
                  is=is+100
               endif

               aa(ntot+4)=is
               if (ic1.gt.0) aa(ntot+29)=vtmp(ic1)
               if (ip1.gt.0) aa(ntot+54)=vtmp(ip1)
               if (ip2.gt.0) aa(ntot+79)=vtmp(ip2)
               if (id1.gt.0) aa(ntot+154)=vtmp(id1)
               if (id2.gt.0) aa(ntot+179)=vtmp(id2)
               if (il1.gt.0) then
                 aa(ntot+104)=vtmp(il1)*c/f1
                 aa(ntot+204)=dble(isn(il1))
c                L1 Lost lock indicator from RINEX (possible cycle-slip)
                 icl=mod(ias(il1),2)
                 if (icl.eq.1) aa(i+254)=1.d0
               endif
               if (il2.gt.0) then
                 aa(ntot+129)=vtmp(il2)*c/f2
                 aa(ntot+229)=dble(isn(il2))
c                L2 Lost lock indicator from RINEX (possible cycle-slip)
                 icl=mod(ias(il2),2)
                 if (icl.eq.1) aa(i+279)=1.d0
               endif

90          continue
           enddo




c .................................  aa(i)  ....................................
c-----------------------------------------------------------------------
c 1  2    3   4  5:29 30:54 55:79 80:104 105:129 130:154 155:179 180:204
cYY GWEEK TOW nsat PRN  C1    P1     P2     L1      L2      D1      D2 
c  (GPS time)                       (meters)                          
c ----------------------------------------------------------------------
c
c ---------------------------------
c 205:229 230:254 255:279 280:304]
c   SN1     SN2    LLI1   LLI2
c     (dB/Hz)
c ---------------------------------
c ..........................................................................

cc         print *,"AA",(aa(i),i=1,304)


c    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c                 READING THE ephemeris from navigation file
c    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

100       continue
c         Reading the RINEX nav .........................
          line=" "
          do i=1,38
           ai(i)=0.d0
          enddo
          read (10,'(a)',end=115,err=115) line
cc          print *, line
c         Updating Klobuchar coefficients and leapsec (if it is the case)
           if (line(61:69).eq."ION ALPHA") then
             read(line,*) alpha0,alpha1,alpha2,alpha3
             goto 100
           endif
           if (line(61:68).eq."ION BETA") then
            read(line,*) beta0,beta1,beta2,beta3
             goto 100
           endif
           if (line(61:64).eq."LEAP") then
            read(line,*) xleapsec
            goto 100
           endif

c         Reading ephemeris ..........................
           if (line(1:2).ne." ") then
             read(line,*,err=100) (ai(i),i=1,6)

             isat=int(ai(1))
             if ((isat.le.0).or.(isat.gt.nts)) goto 100

             if (ai(2).lt.1000.d0) then
              if (ai(2).lt.80.d0) then
                ai(2)=ai(2)+2000.d0
               else
                ai(2)=ai(2)+1900.d0
              endif
             endif

             read(line(19:22),*) ai(7)

             do k=23,61,19
               i=6+(k+15)/19
               read(line(k:k+18),*) ai(i)
             enddo

             do i=1,7
               read (10,'(a)',end=110) line
               do k=4,61,19
                  j=4*i+(k+15)/19+6
                  ai(j)=0.d0
                  if (line(k:k+18).ne."") then
                     read(line(k:k+18),*) ai(j)
                    else
                     if (iprint_mess.ge.1) then
                       print *,"WARNING: holes in the EPH file",isat
                     endif
                  endif
               enddo
             enddo
           endif
c       ...............................................
110     continue

        if ((isat.le.0).or.(isat.gt.nts)) goto 100


c       Transmission time : ai(35)
c       ...... Transmison_time  ................
        tt=ai(29)*w2s+ai(35)

        secb=(ai(5)*60.d0+ai(6))*60.d0+ai(7)
        call sub_cal2dgpsws(ai(2),ai(3),ai(4),secb,idoyb,nwb,swb)
        Toc=swb+w2s*dble(nwb)

        if (ai(35).le.1.d0) then
         if (iprint_mess.ge.3) then
          print *,"WARNING: No transmission time in EPH file"
          print *,"the Toc is used instead: PRN=",isat
         endif
         tt= Toc
        endif
c       Store the transmission time in GPSsec (from GPS t0) in ai(38):
        ai(38)=tt
c       ........................................

c       :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c       Reading and accumulating the last "nr_EPH" for each satellite:
c       All orbits transmitted up to the "observation epoch"+"dt_acum"
c       are considered.
c       (we use the "Toc" and we add "dt_acum" because the RINEX nav. 
c        files are not sorted by transmission time (are sorted by Toc).

cc        if (tt.gt.t+dt_acum) then
        if (Toc.gt.t+dt_acum) then
            do k=1,8
               backspace(10)
            enddo
          else
           do k=1,nac-1
             do j=1,38 
              epha(isat,j,k)=epha(isat,j,k+1)
             enddo
           enddo 
            do j=1,38
              epha(isat,j,nac)=ai(j)
            enddo
            goto 100
        endif
c       :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


115     continue
c       .... Selecting the last HEALTHY transmitted broadcast orbit 
c            for each satellite ....
         do i=1,nts
          tt0(i)=-1.d0
          do k=1,nac  
            tt=epha(i,38,k)
            if ((tt.le.t).and.(tt.gt.tt0(i))) then 
              tt0(i)=tt
              ihealth=nint(epha(i,32,k))
c              print *,"OOO",epha(i,1,k),ihealth
              if (ihealth.eq.0) then
c                 The transmission time cant not be negative
                  inorb=nint(epha(i,35,k))
                  if (inorb.ge.0) then
                    do j=1,38
                     eph(i,j)=epha(i,j,k)
                    enddo
                  endif
                else
                  if (iprint_mess.ge.1) then
                    print *,"UNHEALTHY satellite PRN=",isat
                  endif
              endif
            endif
          enddo
        enddo

c       ............................................................................

ccccccccccccccccccccccccccccccccccccccc
c        do i=1,nts
c          if (epha(i,1,nac).gt.0.d0) then
cc           print *,(epha(i,j,nac),j=1,7),"T",t,epha(i,38,nac)
c          endif
c          if (eph(i,1).gt.0.d0) then
c           print *,(eph(i,j),j=1,7),"T",t,eph(i,38)
c          endif
cc          print *,""
c        enddo
ccccccccccccccccccccccccccccccccccccccc



c       =============== READING REAL TIME MODE DATA =============
35      continue

        if (mrealtime.eq.1) then
         call flush(6)
          read (*,'(a)',end=1000,err=38) line
          read(line(1:3),*,end=38,err=38) typ
          if (typ.eq."OBS") then
            read(line,*,end=38,err=38) xdump,iyear,imon,iday,ihour,
     *         imin,xsec,nn,(aa(i),i=5,4+nn),(aa(i),i=30,29+nn)
            aa(4)=nn
c           ................................
            if (iyear.ge.80) then
               iyear=iyear+1900
              else
               iyear=iyear+2000
            endif

            xyear=dble(iyear)
            xmon=dble(imon)
            xday=dble(iday)
            xhour=dble(ihour)
            xmin=dble(imin)
            secd=((xhour*60.d0)+xmin)*60.d0+xsec

            call sub_cal2dgpsws(xyear,xmon,xday,secd,idoy,nw,sw)
            t=sw+w2s*dble(nw)
            aa(1)=xyear
            aa(2)=dble(nw)
            aa(3)=sw
c           ................................
           elseif (typ.eq."EPH") then
            read(line,*,end=38,err=38) xdump,(ai(i),i=1,38)
            iPRN=nint(ai(1))
            ihealth=nint(ai(32))
cc          print *,"OOO",ihealth,inorb
            if (ihealth.eq.0) then
c              The transmission time cant not be negative
               inorb=nint(ai(35))
               if (inorb.ge.0) then
                 do ik=1,38
                   eph(iPRN,ik)=ai(ik)
                 enddo
               endif
              else
               if (iprint_mess.ge.1) then
                   print *,"UNHEALTHY satellite PRN=",iPRN
               endif
            endif
           elseif (typ.eq."KLB")  then
c            read(line,*,end=38,err=38) name,alpha0,alpha1,
            read(line,*,end=38,err=38) xdump,alpha0,alpha1,
     *       alpha2,alpha3,beta0,beta1,beta2,beta3 
           else
            print *,"ERROR: real-time mode was set"
          endif
        endif 
38      continue
c       ============================================================
        

c    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c           NAVIGATION 
c    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

       nobs=0
       do i=1,nts
         xC1(i)=0.d0
         xL1(i)=0.d0
         xs(i)=0.d0
         ys(i)=0.d0
         zs(i)=0.d0
         dt_sat(i)=0.d0
         PR(i)=0.d0
         URA(i)=0.d0
       enddo

       do i=1,4
         Bi1(i)=0.d0
         Bia(i)=0.d0
         BT1(i)=0.d0
         BTaj(i)=0.d0
       enddo
       do i=1,10
        BTB(i)=0.d0
       enddo

       nsat=nint(aa(4))
       do 50  ii=1,nsat

         iPRN=nint(aa(ii+4))
         i2PRN(ii)=iPRN
         if ((iPRN.le.0).or.(iPRN.gt.nts)) goto 50
         iePRN=nint(eph(iPRN,1))
         if ((iePRN.le.0).or.(iePRN.gt.nts)) then
           if (iprint_mess.ge.2) then
             print *,"No ORBITS for PRN",iPRN," at",iyear,idoy,secd
           endif
           goto 50
         endif

         Toe=eph(iPRN,29)*w2s+eph(iPRN,19)
         dt_orb=t-Toe
         if (dt_orb.lt.dt_cad_eph) then
            do i=1,38
             ee(i)=eph(iPRN,i)
            enddo
           else
             if (iprint_mess.ge.1) then
               print *,"Time-Out eph. PRN=",isat," :dt=",dt_orb
             endif
             goto 50
         endif

c        checking the pseudoranges
         val=aa(ii+29)
         if (val.lt.2000.d0) then
          if (iprint_mess.ge.2) then
             print *,"WARNING: bad code PRN",iPRN,val," at",iyear,idoy,secd
           endif
           goto 50
         endif

         nobs=nobs+1
         i2PRN(nobs)=iPRN

         xC1(nobs)=aa(ii+29)
         xL1(nobs)=aa(ii+104)

c        COMPUTE THE SATELLITE CLOCK and COORDINATES

c        ... GPS satellite clock offset ..............
         secb=(ee(5)*60.d0+ee(6))*60.d0+ee(7)
         call sub_cal2dgpsws(ee(2),ee(3),ee(4),secb,idoyb,nwb,swb)
         Toc=swb+w2s*dble(nwb)

         ddt=t-Toc
         dt_clock=ee(8)+ee(9)*ddt+ee(10)*ddt*ddt
c        ..................................................


c        .... User Range Accuracy (URA) ..............................
c            SPS/SS (2.5.3 User range Accuracy):
c            IURA: URA indicator:
c            (IURA=[1:15])  IURA=15 means no accuracy prediction
c
c             IURA<6 ==>  URA= 2^(1+IURA/2) meters
c               (for: IURA=1,3,5 URA is rounded to 2.8, 5.7 and 11.3)
c
c             IURA>5 ==>  URA= 2^(IURA-2) meters
c             
c             NOTE: The accuracy value is defined to mean 
c                   "no better than X meters" in acordance with 
c                   the previous relationships.
c        .............................................................

         IURA=nint(ee(31))
         if (IURA.eq.1) then
            xURA=2.8d0
          elseif (IURA.eq.2) then
             xURA=4.d0
          elseif (IURA.eq.3) then
             xURA=5.7d0
          elseif (IURA.eq.4) then
             xURA=8.d0
          elseif (IURA.eq.5) then
             xURA=11.3d0
          elseif (IURA.ge.6) then
             xURA=dble(2**(IURA-2))
         endif 
         URA(nobs)=xURA
c        ..............................................................           

cc      ==> Satellite coordinates at RECEPTION time <==
       call sub_GPSnav(iyear,idoy,secd,ee,x,y,z,Ek)
cc       print *,"EPH",(ee(i),i=1,10),ee(35)
cc       print *,"XYZR",iPRN,iyear,idoy,secd,x,y,z,dt_clock*c

c      ==> at "quassi" EMISION time (Except by the receiver clock!) <==

       dtr=xC1(nobs)/c+dt_clock

       if (sat_corr_emis.eq.0) then
         dtr=0.d0
       endif

       secd1=secd-dtr
c       print *,"EE"
       call sub_GPSnav(iyear,idoy,secd1,ee,x0,y0,z0,Ek)
c       print *,"XYZ0",iPRN,iyear,idoy,secd,x0,y0,z0
       xs(nobs)=x0+y0*wt*dtr
       ys(nobs)=y0-x0*wt*dtr
       zs(nobs)=z0      
       dt_sat(nobs)=dt_clock*c


c      ... Relativistic and Group delay (TGD) correction
       trel=xf*ee(16)*ee(18)*dsin(Ek)
       if (make_relat.eq.0) trel=0.d0
       Tgd=ee(33)
       if (make_TGD.eq.0) Tgd=0.d0

c      .... Prefit residual (without rho, iono & tropo) ...........
       PR(nobs)=xC1(nobs)+(dt_clock+trel-Tgd)*c

c       print *,"XYZE",iPRN,iyear,idoy,secd,xs(nobs),ys(nobs),zs(nobs),
c     *    dt_clock*c,trel*c,-Tgd*c,xC1(nobs),PR(nobs)
c       print *," "


c       ... Saving matrix to BANCROFT ..........................
        B(1)=xs(nobs)
        B(2)=ys(nobs)
        B(3)=zs(nobs)
        B(4)=PR(nobs)
  
        aj=(B(1)*B(1)+B(2)*B(2)+B(3)*B(3)-B(4)*B(4))/2.d0
        do i=1,4
         BTaj(i)=BTaj(i)+B(i)*aj
         BT1(i)=BT1(i)+B(i)
         do j=i,4
           BTB(i+j*(j-1)/2)=BTB(i+j*(j-1)/2)+B(i)*B(j)
         enddo
        enddo
c       ......................................................
50      continue


        if (iprint_mess.ge.2) then
          do i=1,nobs
           write(*,'(a4,1x,i02,1x,i4,1x,i3,1x,f8.2,5(1x,f14.3))')
     *      "XYZP",i2PRN(i),iyear,idoy,secd,xC1(i),xs(i),ys(i),zs(i),
     *       dt_sat(i)
          enddo
        endif

        if (nobs.le.3) then 
           write(*,'(i4,1x,i3,1x,f8.2,1x,a26,1x,i1)') iyear,idoy,secd,
     *     "NO position: Nsat avail=",nobs
            goto 20
        endif


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Computing the aproximate position with the BANCROFT Method
c       ==========================================================                

        rrec=r_rec(1)**2+r_rec(2)**2+r_rec(3)**2
        if (rrec.gt.1.d3) then
            goto 70
          else
            if (iprint_mess.ge.0) then
              print *, "COOL START  with Bancroft"
            endif
        endif

120     continue
        call sub_bancroft(BTB,BT1,BTaj,r_rec,dt_rec,ierb)
        ibancroft=1
        if (ierb.ne.0) then
            write(*,'(i4,1x,i3,1x,f8.2,1x,a26)') iyear,idoy,secd,
     *     "NO BANCROFT solution"
           goto 20
        endif
cc        print *,"PPP0"
cc        call sub_car2geo(r_rec(1),r_rec(2),r_rec(3),xlan,xfi,HH)
cc        write(*,'(i4,1x,i3,1x,f8.2,2(1x,f14.8),2(1x,f14.3),1x,i3)')
cc     *    iyear,idoy,secd,xlan,xfi,HH,dt_rec,nobs
cc        print *,"PPP1"
c        goto 80                                                                     
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


c     Computing the FINAL solution from the LINEARIZED Measurement eq.
c     ===============================================================

70      continue

        dtr=-dt_rec/c
        if (sat_corr_emis.eq.0) then
         dtr=0.d0
        endif


        do i=1,4
          GWy(i)=0.d0
        enddo
        do i=1,10
          GWG(i)=0.d0
          GTG(i)=0.d0
        enddo

        ns_used=0
        do 60 i=1,nobs

c         .... Satellite coordinates at the EMISSION time....
c           (adding the last fraction of rotation by the receiver clock)

c         print *,"XYZ0",iPRN,iyear,idoy,secd,x0,y0,z0

          r_sat(1)=xs(i)+ys(i)*wt*dtr
          r_sat(2)=ys(i)-xs(i)*wt*dtr
          r_sat(3)=zs(i)

c         ... Geometric range ...........
          rho=(r_sat(1)-r_rec(1))**2+(r_sat(2)-r_rec(2))**2+
     *        (r_sat(3)-r_rec(3))**2
          rho=dsqrt(rho)

cc         print *,"xyzss",xs(i),ys(i),zs(i)
cc         print *,"r_sat",(r_sat(k),k=1,3),rho,dt_rec         

c         ... Cutt-off elevation control ....
c         This filter is not applyed when the solution has been
c         computed by Bancroft, because it is approximate and
c         could produce de deselection of low elevation satellites.
         
          call cart2geod_elev(r_sat,r_rec,elev,azim,xLat,xLon,heigh)
          if (ibancroft.eq.0) then
            if (elev*r2g.lt.ele_min) goto 60
          endif
c         ...................................

c         ... Ionospheric correction ..........................

          call sub_klob(secd,xLat,xLon,elev,azim,alpha0,
     *       alpha1,alpha2,alpha3,beta0,beta1,beta2,beta3,
     *       xion,sig2_UIRE)

          xion=-xion
          if (make_iono.eq.0) then
            xion=0.d0
            sig2_UIRE=1.d0
          endif

c         ... Tropospheric correction ........................
          call sub_MOPStrop(idoy,heigh,xLat,elev,xtrop,sig2_trop)
          if (make_tropo.eq.0) then
            xtrop=0.d0
            sig2_trop=1.d0
          endif


c         ... Prefit residual ................................
          yy=PR(i)-rho+xion+xtrop

          sig2_URA=URA(i)*URA(i)
          sig2_rec=0.16d0+0.23d0*dexp(-elev*r2g/19.6d0)
          w=sig2_URA+sig2_UIRE+sig2_trop+sig2_rec
          w=1.d0/w
          

c         Linearized Navigation Equations:
c         -------------------------------

c         ... (x,y,z) WGS 84.................
          do k=1,3
            GG(k)=(r_rec(k)-r_sat(k))/rho
          enddo
          GG(4)=1.d0
c         ...................................              

c         .... Building the Position Covariance Matrix:
c         ..........Matrix GWG:=Gt*W*G [positive symmetric matrix]
          do k=1,4
            GWy(k)=GWy(k)+GG(k)*yy*w
            do j=k,4
               GWG(k+j*(j-1)/2)=GWG(k+j*(j-1)/2)+GG(k)*GG(j)*w
               GTG(k+j*(j-1)/2)=GTG(k+j*(j-1)/2)+GG(k)*GG(j)
            enddo
          enddo
c         ...................................................
          ns_used=ns_used+1
60      enddo


        if (ns_used.lt.4) then
             write(*,'(i4,1x,i3,1x,f8.2,1x,a26,1x,i2,1x,a10,i2)')
     *        iyear,idoy,secd,"NO position: Nsat_in_view=",nobs,
     *        "Nsat_used=",ns_used
            if (Nitc.eq.1) then
               if (iprint_mess.ge.2) then
                 print *, "Warning: lossing sat",nobs,ns_used
               endif
               print *, "Cool Start  with Bancroft"
               goto 120
              else
               if (iprint_mess.ge.2) then
                 print *, "WARNING: Skipping this epoch"
               endif
               goto 20
            endif
        endif



c       Computing the NAVIGATION SOLUTION

        Nitc=Nitc+1

        if (Nitc.eq.6) then
            write(*,'(i4,1x,i3,1x,f8.2,1x,a26)') iyear,idoy,secd,
     *     "NO CONV AFTER 5 ITER.: SKIP this time"
           Nitc=0
           goto 20
        endif
 

c       ... GDOP, PDOP, TDOP ...
        call invsp(GTG,4,ier)
        if (ier.ne.0) then
          if (iprint_mess.ge.2) then
            print *,"WARNING: Sing. Matrix: initilize with Bancroft"
          endif
          goto 120
        endif

        GDOP=dsqrt(GTG(1)+GTG(3)+GTG(6)+GTG(10))
        PDOP=dsqrt(GTG(1)+GTG(3)+GTG(6))
        TDOP=dsqrt(GTG(10))
c       .........................................



        call invsp(GWG,4,ier)

        if (ier.ne.0) then
          if (iprint_mess.ge.2) then
            print *,"WARNING: SING. MATRIX: initilize with Bancroft"
          endif
          goto 120
        endif
        
        do i=1,4
          xe(i)=0.d0
          do k=1,4
             if (k.lt.i) ik=k+i*(i-1)/2
             if (k.ge.i) ik=i+k*(k-1)/2
             xe(i)=xe(i)+GWG(ik)*GWy(k)
          enddo
        enddo

        do i=1,3
          r_rec(i)=r_rec(i)+xe(i)
        enddo
        dt_rec=xe(4)
        ibancroft=0

c       ... Solution Convergence Control .......................
        dsol=0.d0
        do i=1,3
          dsol=dsol+xe(i)*xe(i)
        enddo
        dsol=dsqrt(dsol)

        if (iprint_mess.ge.4) then
         call sub_car2geo(r_rec(1),r_rec(2),r_rec(3),xlan,xfi,HH)
         write(*,'(a4,1x,i3,2(1x,f8.2),3(1x,f8.2),3(1x,f12.2),
     *    2(1x,f14.8),1x,f8.3,1x,f14.3,1x,i3)')
     *    "dxyz",idoy,secd,dsol,(xe(i),i=1,3),(r_rec(i),i=1,3),
     *    xlan,xfi,HH,dt_rec,ns_used
        endif


        if (dsol.gt.tol_lin) then
          if (iprint_mess.ge.1) then
            print *,"WARNING: INITIALIZE with BANCROFT",dsol
          endif
          goto 120
        endif

        if (dsol.gt.tol_conv) then
          if (iprint_mess.ge.3) then
           if (Nitc.gt.1) then
             print *,"WARNING: No conv. iteration: N=",Nitc,dsol
           endif
          endif
          goto 70
        endif

        Nitc=0
c       .......................................................

        call sub_car2geo(r_rec(1),r_rec(2),r_rec(3),xlan,xfi,HH)  

c       ... Navigation System Error ....
        if (rr0.gt.1.d0) then
          de=(xlan-xlan0)*dcos(xfi0*g2r)*g2r*6370000.d0
          dn=(xfi-xfi0)*g2r*6370000.d0
          dv=HH-HH0
         else
          de=0.d0
          dn=0.d0
          dv=0.d0
          if (iprint_mess.ge.1) then
             print *,"WARNING: No Reference coordinates r_rec"
          endif
        endif

c ----------------------------------------------------------------------
c YY DOY sec_day  dEast dNorth dUP GDOP PDOP TDOP Long Lat H dt_rec Nsat
c     (GPS time)    (meters)                       (deg)  (meters)
c ----------------------------------------------------------------------

        call sub_car2geo(r_rec(1),r_rec(2),r_rec(3),xlan,xfi,HH)    
        write(*,'(i4,1x,i3,1x,f8.2,3(1x,f8.3),3(1x,f6.2),
     *    2(1x,f14.8),1x,f8.3,1x,f14.3,1x,i3)')
     *    iyear,idoy,secd,de,dn,dv,GDOP,PDOP,TDOP,
     *    xlan,xfi,HH,dt_rec,ns_used


80      continue
        goto 20

1000    continue
        close(10)

        end



c -----------------------------------------------------------------------

         subroutine sub_cal2dgpsws(year,xmonth,day,sec,idoy,nw,sw)
         implicit double precision (a-h,o-z)

c        --------------------------------------------------------
c        Compute the  DOY from YEAR MONTH DAY
c
c        1) Until February 28th of 2100 it calculates consistent doys
c           (days). Outside this range there will be a discrepancy which
c           increases by one day for every non-leap century year.
c        2) If the year is given with only two digits, the range is
c           between 1980 to 2079
c
c        ........................................................
c
c              @ gAGE/UPC (group of Astronomy and Geomatics)
c        --------------------------------------------------------

         xy=year
c        two digits iyear control ...........
         if (xy.lt.1000.d0) then
            if (xy.lt.80.d0) then
               xy=xy+2000.d0
             else
               xy=xy+1900.d0
            endif
         endif
c        ....................................
         xm=xmonth

         jd0=int(365.25d0*(xy-1.d0))+428
         if (xm.le.2.d0) then
           xy=xy-1.d0
           xm=xm+12.d0
         endif
         jd=int(365.25d0*xy)+int(30.6001d0*(xm+1.d0))-jd0
         doy=dble(jd)+day
         idoy=nint(doy)

c        GPS day: (1980jan6.0 => JD=2444244.5 => id_GPS=1.0 )
         id_GPS=jd0+idoy-723263
c        Day of week:
         idw=mod(id_GPS,7)
c        Number of GPS week:
         nw=(id_GPS-idw)/7
c        seconds into the week:
         sw=dble(idw)*86400.d0+sec

         return
         end
c        -----------------------------------------------------------



        subroutine sub_GPSnav(iyear,idoy,sec,a,x,y,z,Ek)
        implicit double precision (a-h,o-z)
        dimension a(*)


c      -------------------------------------------------------------
c       This subroutine computes the WGS-84 coordinates for a GPS
c       satellite at a given epoch (iyear,idoy,sec) in GPS-time,
c       from the navigation message parameters
c
c       INPUT:
c       -----
c        - epoch in which the satellite coordinates must be computed:
c            iyear: YEAR
c            idoy: day of year
c            sec:  second of day
c        - Navigation message (broadcast data)
c          (according to the RINEX format)
c
c            [sat, year,mon,day,h,m,sec, a0,a1,a2     ]
c            [                    IODE,Crs,dn,xMo,    ]
c            [                    Cuc, e, Cus,a12,    ]
c            [                    toe,Cic,Omgg,Cis,   ]
c            [                    xIo,Crc,omgp,Omgd   ]
c            [                    xIDOT,xx,GPS_Week,xx]
c            [                    SVac,SVh,TGD,IODC   ]
c            [                    xx, xx , xx ,xx     ]
c
c      OUTPUT:
c      ------
c             Satellite coordinates in the Earth fixed
c             reference frame WGS-84:(x,y,z) in meters
c             Eccentric annomaly: Ek
c
c  NOTE: 1) The Steffensen iterative method is applied to solve the
c           Kepler equation. This method is more fast and effictient
c           than the Newton-Rapson.
c        2) Until February 28th of 2100 it returns consistent GPS_days
c           (based in Julian days). Outside this range it will be a
c           discrepancy which increases by one day for every non-leap
c           century year.
c        3) If the year is given with only two digits, the range is
c           between 1980 to 2079
c
c
c        ........................................................
c
c              @ gAGE/UPC (group of Astronomy and Geomatics)
c        --------------------------------------------------------



c       Parameters declaration .....
c       WGS-84 Earth Univi. Grav. parameter (m3/s2)
        xmu=3.986005d+14
c       WGS-84 Earth rotation rate (rad/s)
        om_e=7.2921151467d-5
c       ............................


c       GPS Navigation message parameters:
        Crs=a(12)
        dn=a(13)
        xMo=a(14)
        Cuc=a(15)
        e=a(16)
        Cus=a(17)
        a12=a(18)
        toe=a(19)
        Cic=a(20)
        Omgg=a(21)
        Cis=a(22)
        xIo=a(23)
        Crc=a(24)
        omgp=a(25)
        Omgd=a(26)
        xId=a(27)
        iGPSweek=int(a(29))
c       ........................................

c       Computing the GPS_week (nw) and second (sW) into the week......
        xy=dble(iyear) 
c       In RINEX" format year is done with only two digits
        if (xy.lt.1000.d0) then
          if (xy.lt.80.d0) then
            xy=xy+2000.d0
           else
            xy=xy+1900.d0
          endif    
        endif

c       GPS day: (1980jan6.0 => JD=2444244.5 => id_GPS=1.0)
        id_GPS=int(365.25d0*(xy-1.d0))+idoy-722835
c       Day of week:
        idw=mod(id_GPS,7)
c       Number of GPS week:
        nw=(id_GPS-idw)/7
c       seconds into the week:
        sw=dble(idw)*86400.d0+sec

c       Control of GPS WEEK
cc        if (nw.ne.iGPSweek) write(15,*) "ERROR: weeek",iGPSweek,nw

c       Time from current ephemeris epoch
        tk=sw-toe
        if(tk.gt.302400.d0)  tk=tk-604800.d0
        if(tk.lt.-302400.d0) tk=tk+604800.d0
c       Control of age of this orbitas
cc        if (tk.gt.7200.d0) write(15,*)
cc     *  "WARNING:isat,idoy,sec: TK",a(1),idoy,sec,": ",tk," >7200sec"

c       True anomaly fk:
        xMk=xMo+(dsqrt(xmu)/(a12**3)+dn)*tk
        call nsteffensen(xMk,e,Ek)
        fk=datan2(dsqrt(1.d0-e**2)*dsin(Ek),dcos(Ek)-e)

c       Arg. of Latitude uk,radius rk, inclination ik:
        uk=omgp+fk+Cuc*dcos(2.d0*(omgp+fk))+
     *       Cus*dsin(2.d0*(omgp+fk))
        rk=(a12**2)*(1.d0-e*dcos(Ek))+Crc*dcos(2.d0*(omgp+fk))+
     *     Crs*dsin(2.d0*(omgp+fk))
        xIk=xIo+xId*tk+Cic*dcos(2.d0*(omgp+fk))+
     *      Cis*dsin(2.d0*(omgp+fk))

c       Positions in orbital plane
        xp=rk*dcos(uk)
        yp=rk*dsin(uk) 

c       Longitude of ascending node xlmk:
        xlmk=Omgg+(Omgd-om_e)*tk-om_e*toe

c       CT-System coordinates
        x=xp*dcos(xlmk)-yp*dcos(xIk)*dsin(xlmk)
        y=xp*dsin(xlmk)+yp*dcos(xIk)*dcos(xlmk)
        z=yp*dsin(xIk)

        return
        end

c -----------------------------------------------------------------

       subroutine nsteffensen(xm,e,ex)
       implicit double precision (a-h,o-z)

c      --------------------------------------------------------
c      Method to accelerate the Newton-Rapson convergence for
c      equations like:  p=g(p)    (==> E=M+e*sin(E))
c      It is required:  g'(p)<>1  (==> p simple root)
c
c
c      ........................................................
c
c            @ gAGE/UPC (group of Astronomy and Geomatics)
c      --------------------------------------------------------


        tol=1.d-10

        xm=datan2(dsin(xm),dcos(xm))
        p=xm

10      continue
        p0=p
        p1=xm+e*dsin(p0)
        p2=xm+e*dsin(p1)
        dd=dabs(p2-2.d0*p1+p0)
        if(dd.lt.tol) goto 100
        p=p0-(p1-p0)**2/(p2-2.d0*p1+p0)
        if(dabs(p-p0).gt.tol) goto 10

100     continue
        ex=p

       return
       end

c ----------------------------------------------------------------------
        subroutine sub_bancroft(BTB,BT1,BTaj,r_rec,dt_rec,ier)

        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION BTB(10),Bi1(4),Bia(4),BT1(4),BTaj(4),
     *    r_rec(3),coef(3),xM(4),r1(3),r2(3)

c       Computes an aproximate receiver position using the
c       Bancroft method.
c       To discriminate between the two Bancroft solutions,
c       THE CLOSEST SOLUTION TO THE EARTH SURFACE is sleected. 
c
c
c       @gAGE/UPC (group of Astronomy and GEomatics)
c --------------------------------------------------------------


        ier=0
        do i=1,4
          xM(i)=1.d0 
        enddo
        xM(4)=-1.d0       

 
c       Computing the aproximate position with the BANCROFT Method
c       ==========================================================
 
c       ... computing: inv(BTB)
        call invsp(BTB,4,ier)
        if (ier.ne.0) then
          if (iprint_mess.ge.1) then
            print *,"WARNING: Non positive definide matrix, ier=",ier
            goto 100
          endif
          ier=1
        endif
 
c       ... computing: inv(BTB)*BTaj // inv(BTB)*BT1
        do i=1,4
          Bi1(i)=0.d0
          Bia(i)=0.d0
          do j=1,4
            if (j.ge.i) ij=i+j*(j-1)/2
            if (j.lt.i) ij=j+i*(i-1)/2
            Bi1(i)=Bi1(i)+BTB(ij)*BT1(j)
            Bia(i)=Bia(i)+BTB(ij)*BTaj(j)
          enddo
        enddo
 
        do k=1,3
          coef(k)=0.d0
        enddo
        do i=1,4
          coef(1)=coef(1)+Bi1(i)*Bi1(i)*xM(i)
          coef(2)=coef(2)+Bi1(i)*Bia(i)*xM(i)
          coef(3)=coef(3)+Bia(i)*Bia(i)*xM(i)
        enddo
        coef(2)=coef(2)-1.d0
 
        xdcr=coef(2)*coef(2)-coef(1)*coef(3)
        if (xdcr.lt.0.d0) then
          print *, "ERROR: discriminat <0",xdcr,(coef(i),i=1,3)
          ier=1
          goto 100
        endif
        xdcr=dsqrt(xdcr)
        rot1=-(coef(2)+xdcr)/coef(1)
        rot2=-(coef(2)-xdcr)/coef(1)
 
        rr1=0.d0
        rr2=0.d0
        do i=1,3
          r1(i)=rot1*Bi1(i)+Bia(i)
          r2(i)=rot2*Bi1(i)+Bia(i)
          rr1=rr1+r1(i)*r1(i)
          rr2=rr2+r2(i)*r2(i)
        enddo
        rr1=sqrt(rr1)
        rr2=sqrt(rr2)
        dt1=-rot1*Bi1(4)+Bia(4)
        dt2=-rot2*Bi1(4)+Bia(4)
c        print *,"r1=",(r1(i),i=1,3),rr1,dt1
c        print *,"r2=",(r2(i),i=1,3),rr2,dt2
 
c       Selection of true solution:
 
        d1=dabs(rr1-6370000.d0)
        d2=dabs(rr2-6370000.d0)
        if (d1.le.d2) then
            do i=1,3
              r_rec(i)=r1(i)
            enddo
            dt_rec=dt1
          else
            do i=1,3
              r_rec(i)=r2(i)
            enddo
            dt_rec=dt2
        endif

100     continue 
        return
        end


c------------------------------------------------------------------------
        subroutine invsp(A,n,ier)


c       Computes the inverse of a positive defined symmetric matrix
c       The input matrix A is replaced by the output matrix inv(A)
c
c       NOTE:
c        1) Matrix A must be FORTRAN vectored as a symmetric matrix.
c        2) Error messages:
c            ier=1: Matrix A is not positive defined
c            ier=2: det(A)=0
c        3) Use the "chol" subroutine (sub_chol.f)
c
c
c        ** The inverse of a general matrix can be computed as:
c           inv(A)=inv(At*A)*At (where At*A is symmetric and posit.def.)
c
c       ....................................................
c
c        @ gAGE/UPC (group of Astronomy and Geomatics)
c -----------------------------------------------------------------------


        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION A(*)


c       CHOLESKY decomposition (A=T'*T)
        call chol(A,n,ier)

c       Inverse of the cholesky triangular matrix {inv(T)}
        do 10 l=1,n
          i=n-l+1
          A(i+i*(i-1)/2)=1.d0/A(i+i*(i-1)/2)
          do 20 ll=i+1,n
            j=n-ll+i+1
            s=0.d0
            do 30 k=i+1,j
              s=s+A(i+k*(k-1)/2)*A(k+j*(j-1)/2)
30          continue
            A(i+j*(j-1)/2)=-s*A(i+i*(i-1)/2)
20        continue
10      continue

c       Inverse of matrix A   {inv(A)=inv(T)*inv(T)'}
        do 40 i=1,n
          do 50 j=i,n
            s=0.d0
            do 60 k=j,n
              s=s+A(i+k*(k-1)/2)*A(j+k*(k-1)/2)
60          continue
            A(i+j*(j-1)/2)=s
50        continue
40      continue

        return   
        end      

c ----------------------------------------------------------------------

        subroutine chol(a,n,ier)

        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION a(*)

c  ---------------------------------------------------------------------
c      Computes the Cholesky decomposition of a nxn positive defined and
c      symmetric matrix A:  A=Tt*T.
c      In the output, the matrix A is replaced by matrix T
c
c       NOTE:
c        1) Matrix A must be FORTRAN vectored as a symmetric matrix.
c        2) Error messages:
c            ier=1: Matrix A is not positive defined
c            ier=2: det(A)=0
c
c
c    ..................................................
c
c       @ gAGE/UPC (group of Astronomy and Geomatics)
c ----------------------------------------------------------------------



        ier=0

        do 30 i=1,n
        do 20 j=i,n
        sum=a(i+j*(j-1)/2)
        do 10 k=i-1,1,-1
        sum=sum-a(k+i*(i-1)/2)*a(k+j*(j-1)/2)
10      continue
        if (i.eq.j) then
          if(sum.le.0.d0) then
                ier=1
                if (sum.eq.0) ier=2
                goto 100
          endif
          a(i+i*(i-1)/2)=dsqrt(sum)
          else
          a(i+j*(j-1)/2)=sum/a(i+i*(i-1)/2)
        endif
20      continue
30      continue


100     return
        end

c ----------------------------------------------------------------------

        subroutine sub_car2geo(x,y,z,xLon,xLat,H)
        implicit double precision (a-h,o-z)    
 
c       -----------------------------------------------
c       Conversion de coordenadas a cartesianas (x,y,z) 
c       a geodesicas (fi, lambda, h) para WGS84
c
c           x y z ---> |car2geo| ---> fi, lambda, h
c
c
c       Ejecutar por ejemplo:
c
c       echo 4210520.62 1128205.6 4643227.5 | car2geod
c
c       ==> fi, lambda, h  47.  15.  2000.00277 
c
c       -----------------------------------------------
c
c
c
c       @ gAGE/UPC (group of Astronomy and Geomatics)
c ----------------------------------------------------------------------

c
c       ....values declaration........................
        tol=1.d-9
c         WGS84 parameters (in meters)
          a=6378137.d0
          b=6356752.314d0
          e2=(a**2-b**2)/a**2
c       ..............................................


        pi=datan2(1.d0,1.d0)*4.d0  

        xl=datan2(y,x)

        p=dsqrt(x**2+y**2)
        fi=datan(z/p/dsqrt(1.d0-e2))
        fia=fi
20      continue   
        xn=a**2/dsqrt((a*dcos(fi))**2+(b*dsin(fi))**2)
        h=p/dcos(fi)-xn
        fi=datan(z/p/(1.d0-e2*xn/(xn+h)))
        if(dabs(fi-fia).gt.tol) then
           fia=fi
           goto 20
         else
cc           print *, "fi, lambda, h",fi*180.d0/pi,xl*180.d0/pi,h
         xLon=xl*180.d0/pi
         xLat=fi*180.d0/pi
        endif
100     continue


c       xn=a**2/dsqrt((a*dcos(fi))**2+(b*dsin(fi))**2)
c       x=(xn+h)*dcos(fi)*dcos(xl)
c       y=(xn+h)*dcos(fi)*dsin(xl)
c       z=(b**2/a**2*xn+h)*dsin(fi)
c       print *, x,y,z

        return
        end
c ----------------------------------------------------------------------

c234567
      subroutine cart2geod_elev(r_sat,r_sta,elev,azim,fi,xl,h)

      implicit double precision (a-h,o-z)
      dimension r_sat(3),r_sta(3),xi(3),xj(3),xk(3)

c     ------------------------------------------------------
c     This subroutine computes the geodetic elevation and
c     azimuth (WGS84) from topocentric coordinates (CTS)
c
c     [x y z]sat [x y z]sta --->
c                    ---> |cart2geod_elev| ---> elev,azim
c                                               (radians)
c
c     For instance:
c
c     echo -38552.01 -15574546.90 2162755.50
c         4849202.52 -360329.17 4114913.06 | cart2geod_elev
c
c     ==> geodetic_elev:
c         fi, lamba, h 40.4291601 -4.24966129 829.479774
c         elevation, azimuth 21.0232388 -44.5855419
c
c
c     ........................................................
c
c           @ gAGE/UPC (group of Astronomy and Geomatics)
c     --------------------------------------------------------
c
c
c     .......values declaration..........
      tol=1.d-9
c     WGS84 parameters (in meters)
      a=6378137.d0
      b=6356752.314d0
      e2=(a**2-b**2)/a**2
c     ...................................


      pi=datan2(1.d0,1.d0)*4.d0

      x=r_sta(1)
      y=r_sta(2)
      z=r_sta(3)

      xl=datan2(y,x)

      p=dsqrt(x**2+y**2)
      fi=datan(z/p/dsqrt(1.d0-e2))
      fia=fi
20    continue
      xn=a**2/dsqrt((a*dcos(fi))**2+(b*dsin(fi))**2)
      h=p/dcos(fi)-xn
      fi=datan(z/p/(1.d0-e2*xn/(xn+h)))
      if(dabs(fi-fia) .gt. tol) then
         fia=fi
         goto 20
      else

      endif



c     local coordinate frame ................................
      xi(1)=-dsin(fi)*dcos(xl)
      xi(2)=-dsin(fi)*dsin(xl)
      xi(3)=dcos(fi)

      xj(1)=-dsin(xl)
      xj(2)=dcos(xl)
      xj(3)=0.d0


      xk(1)=dcos(fi)*dcos(xl)
      xk(2)=dcos(fi)*dsin(xl)
      xk(3)=dsin(fi)
c     .......................................................

      drm=0.d0
      do i=1,3
         drm=drm+(r_sat(i)-r_sta(i))**2
      enddo

      dri=((r_sat(1)-r_sta(1))*xi(1)+(r_sat(2)-r_sta(2))*xi(2)+
     *     (r_sat(3)-r_sta(3))*xi(3))/drm

      drj=((r_sat(1)-r_sta(1))*xj(1)+(r_sat(2)-r_sta(2))*xj(2)+
     *     (r_sat(3)-r_sta(3))*xj(3))/drm

      drk=((r_sat(1)-r_sta(1))*xk(1)+(r_sat(2)-r_sta(2))*xk(2)+
     *     (r_sat(3)-r_sta(3))*xk(3))/drm

      azim=datan2(drj,dri)
      if (azim.ne.0.d0) then
          elev=datan2(drj/dsin(azim),drk)
      else
          elev=dasin(dri)
      endif
          elev=pi/2.d0-elev

      return
      end                                                                                  
c ----------------------------------------------------------------------

        subroutine sub_klob(t,ulat,ulon,elev,azim,alpha0,
     *   alpha1,alpha2,alpha3,beta0,beta1,beta2,beta3,
     *   Tiono,sig2_UIRE)

        implicit double precision (a-h,o-z)

c ----------------------------------------------------------
c  This subroutine implements the Klobuchar model for the L1
c  ionospheric delay computation.
c
c  INPUT:
c        t   : observation epoch (seconds of day)
c        (ulat,ulon): receiver geodetic coordinates (WGS84) (meters)
c        (elev,azim): satellite geodetic elev y azim (radians)
c
c        Klobuchar Coefficients (file klobuchar.dat):
c           alpha0,alpha1,alpha
c           beta0,beta1,beta2,beta3
c  OUTPUT:
c        Tiono: ionosferic delay (meters of L1)
c
c
c
c
c ...........................................................
c
c        @ gAGE/UPC (group of Astronomy and Geomatics)
c -----------------------------------------------------------



c   ... parameter declarations ......
        c=299792458.d0   
        pi=3.1415926535898d0       
c   .................................


c  ============================================================

c   Compute the Earth-centered angle fm (in semicircles): ........
        fm=0.0137d0/(elev/pi+0.11d0)-0.022d0

c   Compute the subionospheric latitude, xilat (in semicircles): ...
        xilat=ulat/pi+fm*dcos(azim)
        if (xilat.gt. 0.416d0) xilat= 0.416d0
        if (xilat.lt.-0.416d0) xilat=-0.416d0

c   Compute the subionospheric longitude, xilon (in semicircles): ..
        xilon=ulon/pi+fm*dsin(azim)/dcos(xilat*pi)

c   Find the Geomagnetic latitude gmlat (in semicircles): ...
        gmlat=xilat+0.064d0*dcos((xilon-1.617d0)*pi)

c   Find the local time at the subionspheric point: tsub (in sec.)
        tsub=4.32d4*xilon+t
        if (tsub .gt. 86400.d0) tsub=tsub-86400.d0
        if (tsub .lt. 0.d0) tsub=tsub+86400.d0

c   Convert to slant time delay (compute the slant factor F):
        F=1.d0+16.d0 *(0.53d0-elev/pi)**3
c   Compute the ionospheric time delay sTEC (in meters of delay):
        alpha=alpha0+alpha1*gmlat+alpha2*gmlat**2+alpha3*gmlat**3
        beta= beta0+beta1*gmlat+beta2*gmlat**2+beta3*gmlat**3
        if (alpha.lt.0.d0) alpha=0.d0
        if (beta.lt.72000.d0) beta=72000.d0
        x=2.d0*pi*(tsub-50400.d0)/beta

        if (dabs(x).le.pi/2.d0) then
           y=alpha*(1.d0-x**2/2.d0+x**4/24.d0)
         else
           y=0.d0
        endif

        Tiono=F*(5.d-9+y)*c

c  Compute the sigma_UIRE

        gmlat=dabs(gmlat)*180.d0
        tau_vert=4.5d0
        if(gmlat.le.20.d0) tau_vert=9.d0
        if(gmlat.gt.55.d0) tau_vert=6.d0

c   Compute the sig2_UIRE
        sig2_UIRE=(Tiono/5.d0)**2
        fact=(F*tau_vert)**2
        if (fact.gt.sig2_UIRE) sig2_UIRE=fact

        return
        end

c   ---------------------------------------------------------------

      SUBROUTINE sub_MOPStrop(idoy,H,xfir,elevr,TC,sigma2_trop)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION avr(5,5),svr(5,5),xfi0(5),avr0(5),svr0(5),
     *          xi(5)

c -------------------------------------------------------------
c  MOPS tropospheric model (appendix A.4.2.4)
c
c  INPUTS:  idoy,H,xfi,elev
c 
c  OUTPUTS: TC,sigma2_trop
c
c  H= height over the mean-sea-level (meters)
c  xfi= receiver latitude (rad)
c  elev=satellite elevation from receiver (rad)
c
c  TC= tropospheric correction (meters of delay)
c  sigma2_trop= residual error for tropospheric delay (meters**2)
c --------------------------------------------------------------
c       @gAGE/UPC (group of Astronomy and GEomatics)
c --------------------------------------------------------------
c       Constants declaration ............
        pi=3.1415926535898d0
        xk1=77.604d0
        xk2=382000.d0
        Rd=287.054d0
        g=9.80665d0
        gm=9.784d0

c       .................Average....................
        data (avr(1,j),j=1,5) /
     *   1013.25d0,299.65d0,26.31d0,6.30d-3,2.77d0 /
        data (avr(2,j),j=1,5) /
     *   1017.25d0,294.15d0,21.79d0,6.05d-3,3.15d0 /
        data (avr(3,j),j=1,5) /
     *   1015.75d0,283.15d0,11.66d0,5.58d-3,2.57d0 /
        data (avr(4,j),j=1,5) /
     *   1011.75d0,272.15d0, 6.78d0,5.39d-3,1.81d0 /
        data (avr(5,j),j=1,5) /
     *   1013.00d0,263.65d0, 4.11d0,4.53d-3,1.55d0 /
c       ..........Seasonal Variation................
        data (svr(1,j),j=1,5) /
     *    0.00d0, 0.00d0,0.00d0,0.00d-3,0.00d0 /
        data (svr(2,j),j=1,5) /
     *   -3.75d0, 7.00d0,8.85d0,0.25d-3,0.33d0 /
        data (svr(3,j),j=1,5) /
     *   -2.25d0,11.00d0,7.24d0,0.32d-3,0.46d0 /
        data (svr(4,j),j=1,5) /
     *   -1.75d0,15.00d0,5.36d0,0.81d-3,0.74d0 /
        data (svr(5,j),j=1,5) /
     *   -0.50d0,14.50d0,3.39d0,0.62d-3,0.30d0 /
c       .............Latitude bands.................
        data (xfi0(i),i=1,5) /15.d0,30.d0,45.d0,60.d0,75.d0/
c       ............................................

c      from radians to degrees
       xfi=xfir*180.d0/pi
       elev=elevr*180.d0/pi
c      ........................

        if (xfi.ge.0.d0) then
          idmin=28
         else
          idmin=211
        endif
        dd=dble(idoy-idmin)
        xfact=2.d0*pi*dd/365.25d0

        elevr=elev*pi/180.d0
        axfi=dabs(xfi)

        if  (axfi.le.15.d0) index=1
        if ((axfi.gt.15.d0).and.(axfi.le.30.d0)) index=2
        if ((axfi.gt.30.d0).and.(axfi.le.45.d0)) index=3
        if ((axfi.gt.45.d0).and.(axfi.le.60.d0)) index=4
        if ((axfi.gt.60.d0).and.(axfi.le.75.d0)) index=5
        if (axfi.gt.75.d0) index=6

        do j=1,5
         if (index.eq.1) then
            avr0(j)=avr(index,j)
            svr0(j)=svr(index,j)
           else    
            if (index.lt.6) then
              avr0(j)=avr(index-1,j)+(avr(index,j)-avr(index-1,j))*
     *            (axfi-xfi0(index-1))/(xfi0(index)-xfi0(index-1))
              svr0(j)=svr(index-1,j)+(svr(index,j)-svr(index-1,j))*
     *            (axfi-xfi0(index-1))/(xfi0(index)-xfi0(index-1))
             else
              avr0(j)=avr(index-1,j)
              svr0(j)=svr(index-1,j)
            endif
         endif
         xi(j)=avr0(j)-svr0(j)*dcos(xfact)
        enddo

        P=xi(1)
        T=xi(2)
        e=xi(3)
        beta=xi(4)
        xlambda=xi(5)

c       Zero-altitude zenith delay terms:

        z_hyd=1.d-6*xk1*Rd*P/gm
        z_wet=1.d-6*xk2*Rd/(gm*(xlambda+1.d0)-beta*Rd)*e/T

c       zenith delay terms at H meters of height avove mean-see-level

        exp1=g/Rd/beta
        d_hyd=z_hyd*(1.d0-beta*H/T)**exp1

        exp2=((xlambda+1.d0)*g/Rd/beta)-1.d0
        d_wet=z_wet*(1.d0-beta*H/T)**exp2

c       Tropospheric mapping function:
        xmap=dsqrt(0.002001d0+(dsin(elevr))**2)
        xmap=1.001d0/xmap

c       Tropospheric correction
        TC=-(d_hyd+d_wet)*xmap

c       residual error for tropospheric delay
        sigma2_trop=(0.12d0*xmap)**2

        return
        end


c  ---------------------------------------------------------------------




c        f77 -O3 -o  Gnav03 Gnav03.f
