c234567890

        subroutine car2geo(x,y,z,xlon,xlat,h)
        implicit double precision (a-h,o-z)             

c -----------------------------------------------------------
c       Conversion from Cartesian coordinates (x,y,z) 
c       to ellipsoidal (fi,lambda,h) for WGS84
c
c       sta x y z ---> |car2geo| ---> xlon,xlat, h
c
c       
c       xlon: geodetic longitude  
c       xlat: geodetic latitude
c       h:  height over the ellipsoid
c
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c -----------------------------------------------------------

c	....value declaration........................
        tol=1.d-9
        pi=3.1415926535898d0 
c         WGS84 parameters (in meters)
          a=6378137.d0
          f=1.d0/298.257223563
          b=a*(1.d0-f)
	  e2=(a**2-b**2)/a**2
c       ..............................................


        xl=datan2(y,x)
        p=dsqrt(x**2+y**2)
        fi=datan(z/p/(1.d0-e2))
        fia=fi
20      continue   
        xn=a**2/dsqrt((a*dcos(fi))**2+(b*dsin(fi))**2)
        h=p/dcos(fi)-xn
        fi=datan(z/p/(1.d0-e2*xn/(xn+h)))
        if(dabs(fi-fia).gt.tol) then
           fia=fi
           goto 20
        endif

        xlon=xl
        xlat=fi
         
        return
        end
	

c        xn=a**2/dsqrt((a*dcos(fi))**2+(b*dsin(fi))**2)
c        x=(xn+h)*dcos(fi)*dcos(xl)
c        y=(xn+h)*dcos(fi)*dsin(xl)
c        z=(b**2/a**2*xn+h)*dsin(fi)
c        write(*,'(a4,3(1x,f15.4))') "ORG", x,y,z

c        f77 -c  car2geo.f
