cx234567
      implicit double precision (a-h,o-z)
       dimension p(6),r0(3),r(3),rot1(9),rot2(9),
     * rot3(9)

c   .........................................................
c
c
c  sat,day,seg,[a,e,i,OMEGA,omega,Mo]-->|orb2xyz|-->isat,iday,
c                                                   time,
c                                                   r_sat_topo
c
c   NOTE:
c   z => North Pole
c   If W (asc. node long.) referring to Aries  => x to Aries
c   If W (asc. node long. ) referring to Green. => x to Green.
c
c       Note: in the files *eph and *b
c             W is referring to Greenwich
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c   ----------------------------------------------------------

        do i=1,3
          r0(i)=0.d0
        enddo

10      continue
        read (*,*,end=100) isat,id,t,p
        call kepler(p(6),p(2),ex)
        r0(1)=p(1)*(1.d0-p(2)*dcos(ex))
        xv=datan2(dsqrt(1.d0-p(2)**2)*dsin(ex),dcos(ex)-p(2))
        call rotate(3,-p(5)-xv,rot3)
        call rotate(1,-p(3),rot1)
        call prod(rot1,3,3,rot3,3,3,rot2)
        call rotate(3,-p(4),rot3)
        call prod(rot3,3,3,rot2,3,3,rot1)
        call prod(rot1,3,3,r0,3,1,r)
        write(*,*) isat,id,t,r
        goto 10

100     end

c  -----------------------------------------------------------            
       subroutine kepler(xm,e,ex)
       implicit double precision (a-h,o-z)

       eps=1.d-12
       ex=xm

10     dex=xm-(ex-e*dsin(ex))
       ex=ex+dex
       if (dex .gt. eps) goto 10
       return
       end
c ------------------------------------------------------------
       subroutine rotate(iaxis,angle,rot)
       implicit DOUBLE PRECISION (A-H,O-Z)
       dimension rot(9)

c -----------------------------------------------------------
c      It provides the (Fortran vectored) rotation matrix "rot"
c      for a given angle "angle" arround the coordinate axis
c      [1<=>x], [2<=>y],[3<=>z].
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

       do i=1,9
           rot(i)=0.d0
       enddo

       if (iaxis .eq. 1) then
           rot(1)=1.d0
           rot(5)=dcos(angle)
           rot(6)=-dsin(angle)
           rot(8)=dsin(angle)
           rot(9)=dcos(angle)
         elseif (iaxis .eq. 2) then
           rot(5)=1.d0
           rot(1)=dcos(angle)
           rot(7)=-dsin(angle)
           rot(3)=dsin(angle)
           rot(9)=dcos(angle)
         elseif (iaxis .eq. 3) then
           rot(9)=1.d0
           rot(1)=dcos(angle)
           rot(2)=-dsin(angle)
           rot(4)=dsin(angle)
           rot(5)=dcos(angle)
       endif

       return
       end
c ------------------------------------------------------------
       subroutine prod(A,m,l,B,ll,n,C)
       implicit DOUBLE PRECISION (A-H,O-Z)
       dimension A(*),B(*),C(*)

c ------------------------------------------------------------
c      It computes the product of a mxl matrix A and a llxn
c      matrix B. The result is the mxn matrix C. The matrix
c      must be general matrix, Fortran vectored (by collumns).
c
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

       do i=1,m*n
          C(i)=0.d0
       enddo

       if (l.ne.ll) then
          print *, "ERROR: dimension matrix"
        goto 100
       endif

        do 10 i=1,m
          do 20 j=1,n
            C(i+m*(j-1))=0.d0
            do 30 k=1,l
              C(i+m*(j-1))=C(i+m*(j-1))+A(i+m*(k-1))*B(k+l*(j-1))
30          enddo
20        enddo
10      enddo

100    continue
       return
       end
c ------------------------------------------------------------


c      f77 -o ele_orb2xyz ele_orb2xyz.f
                                                              
