c234567
      implicit double precision (a-h,o-z)
      dimension r(3), rp(3)

c ------------------------------------------------------------
c
c          (t_sid,x,y,z)  -----> |eq2wgs| --------> (x,y,z)
c      equatorial coord.                               WGS84
c          x => Aries                          x => Greenwich
c          z => North Pole                     z => North Pole
c   Example:
c    echo "3.460 4099.155 17543.866 -19390.923"|eq2wgs
c
c    @gAGE (Research group of Astronomy and GEomatics). UPC

c ------------------------------------------------------------

        pi=3.1415926535898d0

        read (*,*) ts,r
        ts=ts*pi/12.d0
        call rot3(ts,r,rp)

        write(*,'(f12.5,1x,f12.5,1x,f12.5)') rp

        end
c ____________________________________________________________

        subroutine rot3(ang,r,rp)
        implicit double precision (a-h,o-z)
        dimension r(3),rp(3)

        rp(1)=cos(ang)*r(1)+sin(ang)*r(2)
        rp(2)=-sin(ang)*r(1)+cos(ang)*r(2)
        rp(3)=r(3)
        end
c ------------------------------------------------------------                 


c    f77 -o  eq2wgs eq2wgs.f
