c234567
      implicit double precision (a-h,o-z)
      dimension r(3), rp(3)

c ------------------------------------------------------------
c
c   (yy,mm,dd,hh,x,y,z)  -----> |eq2wgs_ts| ------> (x,y,z)
c     equatorial coord.                               WGS84
c      x => Aries                              x => Greenwich
c      z => North Pole                        z => North Pole
c
c Example:
c     echo "1998 11 13 0 4099.15 17543.86 -19390.92"|eq2wgs_ts
c
c    @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

        pi=3.1415926535898d0
10      continue
        read(*,*,end=100) ay,am,ad,ah,r

c       Calculo del tiempo sidereo
        call sid0TU(ay,am,ad,ts)
c        ts=ts+(365.2422d0/364.2422d0)*ah
        ts=ts+1.00273790934d0*ah
        ts=dmod(ts,24.d0)

        ts=ts*pi/12.d0
c       Transformacion de coordenadas
        call rot3(ts,r,rp)
c       print *, ts
        write(*,'(f12.5,1x,f12.5,1x,f12.5)') rp
        goto 10

100     continue
        end
c ____________________________________________________________
        subroutine rot3(ang,r,rp)
        implicit double precision (a-h,o-z)
        dimension r(3),rp(3)

        rp(1)=dcos(ang)*r(1)+dsin(ang)*r(2)
        rp(2)=-dsin(ang)*r(1)+dcos(ang)*r(2)
        rp(3)=r(3)

        end
c ------------------------------------------------------------
        subroutine sid0TU(xy,xm,xd,sid)
        implicit double precision (a-h,o-z)
        double precision jd

c       Calculo del tiempo sidereo a 0h TU

c       ----------------------------------------------------
c       anyo mes dia  -->|sid0TU|-->  sid(hh.hh)
c       ----------------------------------------------------

        if (xm.le.2.d0) then
           xy=xy-1.d0
           xm=xm+12.d0
        endif

c       dia juliano (jd)
        jd=int(365.25d0*xy)+int(30.6001d0*(xm+1.d0))+xd
     *  +1720981.5d0

c       print *,xy,xm,xd,jd
c       Calculo tiempo sidereo a 0h TU (sid)
        tt=(jd-2451545.d0)/36525.d0

        sid=24110.54841d0+8640184.812866d0*tt
     *      +0.093104d0*tt**2-(6.2d-6)*(tt**3)
        sid=sid/3600.d0
        sid=dmod(sid,24.d0)
        if (sid.lt.0.d0) sid=sid+24.d0
        end
c ------------------------------------------------------------                

c    f77 -o  eq2wgs_ts eq2wgs_ts.f
