c234567
      implicit double precision (a-h,o-z)
      dimension r(3), rp(3)

c ------------------------------------------------------------
c
c         (t_sid,x,y,z)  ---->|wgs2eq| ---> (x,y,z)
c              WGS84                      equatorial coord.
c        x => Greenwich                    x => Aries
c        z => North Pole                   z => North Pole
c
c   Example:
c            echo "3.460 16336.506 7596.636 -19390.923"|wgs2eq
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

        pi=3.1415926535898d0

        read (*,*) ts,r
        ts=ts*pi/12.d0
        call rot3(-ts,r,rp)

        write(*,'(f12.5,1x,f12.5,1x,f12.5)') rp

        end
c _____________________________________________________________

        subroutine rot3(ang,r,rp)
        implicit double precision (a-h,o-z)
        dimension r(3),rp(3)

        rp(1)=cos(ang)*r(1)+sin(ang)*r(2)
        rp(2)=-sin(ang)*r(1)+cos(ang)*r(2)
        rp(3)=r(3)
        end
c -------------------------------------------------------------                


c     f77 -o wgs2eq wgs2eq.f
