c234567
      implicit double precision (a-h,o-z)
      dimension r(3), rp(3)

c ------------------------------------------------------------
c
c       (yy mm dd UT,x,y,z)  ---->|wgs2eq_ts| ---> (x,y,z)
c           WGS84                         equatorial coord.
c        x => Greenwich                    x => Aries
c        z => North Pole                   z => North Pole
c
c  Example:
c  echo "1998 11 13 0 16336.5 7596.6 -19390.9 "|wgs2eq_ts
c
c    @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

        pi=3.1415926535898d0

        read (*,*)  ay,am,ad,ah,r

c       Calculo del tiempo sidereo
        call sid0TU(ay,am,ad,ts)
        ts=ts+1.00273790934d0*ah
        ts=dmod(ts,24.d0)
c       print *, ay,am,ad,ah,ts
        ts=ts*pi/12.d0

c       Transformacion de coordenadas
        call rot3(-ts,r,rp)

        write(*,'(f12.5,1x,f12.5,1x,f12.5)') rp

        end

c ____________________________________________________________

        subroutine rot3(ang,r,rp)
        implicit double precision (a-h,o-z)
        dimension r(3),rp(3)

        rp(1)=dcos(ang)*r(1)+dsin(ang)*r(2)
        rp(2)=-dsin(ang)*r(1)+dcos(ang)*r(2)
        rp(3)=r(3)
        end
c ------------------------------------------------------------
        subroutine sid0TU(xy,xm,xd,sid)
        implicit double precision (a-h,o-z)
        double precision jd

c       ----------------------------------------------------
c       anyo mes dia -->|sid0TU|--> sid(hh.hh)
c       ----------------------------------------------------                    

        if (xm.le.2.) then
           xy=xy-1.d0
           xm=xm+12.d0
        endif

c       dia juliano (jd)
        jd=int(365.25d0*xy)+int(30.6001d0*(xm+1.d0))+xd+
     * +1720981.5d0

c       Calculo del tiempo sidereo a 0h TU(sid)
        tt=(jd-2451545.d0)/36525.d0

        sid=24110.54841d0+8640184.812866d0*tt
     *      +0.093104d0*tt**2-(6.2d-6)*(tt**3)
        sid=sid/3600.d0
        sid=dmod(sid,24.d0)
        if (sid.lt.0.d0) sid=sid+24.d0

        end
c ------------------------------------------------------------
                                                                          

c     f77 -o wgs2eq_ts wgs2eq_ts.f
