c234567890
        implicit double precision (a-h,o-z)
        double precision jd

c       ------------------------------------------------------
c       It calculates the JULIAN DAY  and the SIDEREAL MEAN
c       time for a determined date and hour (that is to say, the
c       hour angle at the Aries point):
c       year month day hour(UT)-->|ymdUT2sid|--> jd sid(hh.hh)
c       Execute:
c         echo "1978 11 13 0"| ymdUT2sid
c         result:
c                  2443825.5    3.45038611041   3  27  1.39000
c
c       @gAGE (group of Astronomy and GEomatics). UPC

c       ------------------------------------------------------
        read(*,*) xy,xm,xd,xt
        if (xm.le.2.d0) then
           xy=xy-1.d0
           xm=xm+12.d0
        endif
        jd=int(365.25d0*xy)+int(30.6001d0*(xm+1.d0))+xd
     *     +xt/24.d0+1720981.5d0
        tt=(jd-2451545.d0)/36525.d0
        sid1=24110.54841d0+8640184.812866d0*tt
     *       +0.093104d0*tt**2-(6.2d-6)*(tt**3)
        sid1=(sid1/3600.d0+xt)
        sid1=dmod(sid1,24.d0)
        if (sid1.lt.0.d0) sid1=sid1+24.d0
        ih=int(sid1)
        xmm=(sid1-dble(ih))*60.d0
        mm=int(xmm)
        xss=(xmm-dble(mm))*60.d0
        write(*,'(f10.1,1x,f16.11,1x,i3,1x,i3,1x,f8.5)')
     *        jd, sid1, ih,mm,xss
        end 


c    f77 -o  ymdUT2sid ymdUT2sid.f                                                                  
